      real*8 function interp_gc(pnot)
c
c interpolate the gravity correction
c
c input:
c pnot - pressure of the desire point for gravity correction
c        of the total column number density [atm]
c
      implicit none
      include 'atm_101.cmn'
c passed in
      real*8 pnot
c
      integer mode
      real*8 yp1,ypn,junk(2)
c

          yp1=1.0e30
          ypn=1.0e30 
          mode=0
          call spline(p_101lg,gc_factor,n_101,yp1,ypn,y2_101,mode)
          junk(1)=dlog(pnot)
          call splint(p_101lg,gc_factor,y2_101,n_101,junk(1),junk(2),
     &mode)
          interp_gc=junk(2)
          return
          end
