c  $Header: /usr/people/flittner/radtran/tomrad/pv2.2/src/RCS/cp101.f,v 2.22 2000/08/30 16:38:09 flittner Exp $
      subroutine cp101()
c
c*****define pressures (atm.) at 101 levels for output ozone and
c     temperatures by dividing the atmosphere into 101 layers by
c     a linear interpolation of log(p) (pmax=1, pmin=1.0e-5)
c  p_101(101) is at the bottom of the atmosphere
c
c     p101(101)     r*8          pressure (atm.) at 101 atmospheric
c                                levels that define the output layer
c                                ozone amounts and temperatures
c
      implicit none
      include 'atm_101.cmn'
c local
      integer i
c
      do i=1,n_101
         p_101(i)=1.0*10.**((i-101.)/20.)
         p_101lg(i)=dlog(p_101(i))
      enddo
      return
      end
